<?php

/**
* Copyright (C) 2005 Grummfy
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**#@+
* @deprecated Constante de type de sortie
*/
/**
* par dfaut : html
*/
define('CALENDAR_TYPE_HTML', 1);
/**
* xml
*/
define('CALENDAR_TYPE_XML', 2);
/**#@-*/

/**#@+
* @deprecated Constante de priode de calendrier
*/
/**
* par jour
*/
//define('CALENDAR_PERIODE_DAY', 1);
/**
* par dfaut : par mois
*/
define('CALENDAR_PERIODE_MONTH', 3);
/**#@-*/

/**#@+
* @deprecated Constante du premier jour de calendrier
*/
/**
* lundi
*/
define('CALENDAR_DAY_MON', 1);
/**
* mardi
*/
define('CALENDAR_DAY_TUE', 2);
/**
* mercredi
*/
define('CALENDAR_DAY_WED', 3);
/**
* jeudi
*/
define('CALENDAR_DAY_THU', 4);
/**
* vendredi
*/
define('CALENDAR_DAY_FRI', 5);
/**
* samedi
*/
define('CALENDAR_DAY_SAT', 6);
/**
* dimanche
**/
define('CALENDAR_DAY_SUN', 0);
/**#@-*/

/**#@+
* @deprecated Constante de la longeur du jour ou du mois de calendrier
*/
/**
* en chiffre : par dfaut
*/
define('CALENDAR_SHORT_DAY', 1);
/**
* en raccourci
*/
define('CALENDAR_MEDIUM_DAY', 2);
/**
* en plein
*/
define('CALENDAR_LONG_DAY', 3);
/**#@-*/

/**
* Class calendrier, permetant de gnrer un calendrier sous diffrent format.
* @author Grummfy <grummfy@yahoo.fr>
* @copyright Grummfy 20/10/2005
* @link  http://www.grummfy.com Grummfy
* @version 0.9.1
* @package Calendar
* @license http://www.gnu.org/licenses/lgpl.html LGPL (GNU Lesser General Public License)
*/
class calendar
{
	/**#@+
	* @access private
	*/
	/**
	* type de sortie
	* @var const
	*/
	var $html_v;
	/**
	* priode de calendrier
	* @var const
	*/
	var $periode;
	/**
	* nombre de priode
	* @var int
	*/
	var $nbr_periode = 0;
	/**
	* premier jour de calendrier
	* @var const
	*/
	var $fday;
	/**
	* dbut du calendrier
	* @var timestamp
	*/
	var $ftime;
	/**
	* Contient les vnements
	* @var array
	*/
	var $evenement = array();
	/**
	* Traduction des jours
	* @var array
	*/
	var $lng_day = array();
	/**
	* Traduction des mois
	* @var array
	*/
	var $lng_month = array();
	/**
	* Longeur des jours
	* @var const
	*/
	var $short_day;
	/**
	* Longeur des mois
	* @var const
	*/
	var $short_month;
	/**#@-*/

	/**
	* Crer une instance de la class calendar et initialise les variables par dfaut
	*/
	function calendar()
	{
		$this->reset();
	}

	/**
	* Renvoi true si c'est une anne bisextille, sinon renvoi false
	*
	* Renvoi true si c'est une anne bisextille, sinon renvoi false.
	* $time peux soit tre une anne soit tre un timestamp. Si c'est uen anne il faut mettre le paramtre $timestamp_or_year = false.
	* @param timestamp $time
	* @param year $time
	* @param boolean $timestamp_or_year si true -> un timestamp, false -> une anne  4 chiffres
	* @return boolean vrai si c'est bisextille
	*/
	function is_bisextille ($time, $timestamp_or_year = true)
	{
		if ( $timestamp_or_year )
		{
			return ( (intval($time) % 4) == 0 )? true:false;
		}
		else
		{
			return ( (date("Y",intval($time)) % 4) == 0 )? true:false;
		}
	}

	/**
	* Dfinit le format de sortie
	* @param const $format Cosntante de type
	*/
	function set_format($format = CALENDAR_TYPE_HTML)
	{
		$this->html_v = $format;
	}

	/**
	* Permet de dfinir la date du dbut du calendrier
	*
	* Permet de dfinir la date du dbut du calendrier
	* On dfinit la date du dbut du calendrier, est optionel.
	*
	* @param int $day jour du dbut
	* @param int $month mois du dbut
	* @param int $year anne du dbut
	*/
	function set_debut($day, $month, $year)
	{
		$this->ftime = mktime(0, 0, 0, intval($month), intval($day), intval($year));
	}

	/**
	* Permet de dfinir la priode de temps qui sera affiche
	* @param int $nbr_periode nombre de priode  afficher
	* @param const $periode type de priode
	*/
	function set_periode($nbr_periode = 1, $periode = CALENDAR_PERIODE_MONTH)
	{
		$this->nbr_periode = intval($nbr_periode);
		$this->periode = $periode;
	}

	/**
	* Permet de dfinir le premier jour de la semaine
	* @param const $day jour de la semaine
	*/
	function set_first_day($day = CALENDAR_DAY_MON)
	{
		$this->fday = $day;
	}

	/**
	* Permet d'ajouter un vnement au calendrier avec un lien
	* @param string $description description courte de l'vnement
	* @param string $description_long description longue ( optionnel )
	* @param string $lien lien vers l'vnement ( optionnel )
	* @param string $nom_lien texte qui sera affich sur le lien ( optionnel )
	* @param string $nom nom de l'vnement
	* @param boolean $lien_out true si on met target="_blank" ( optionnel )
	* @param timestamp $timestamp date de l'venement
	*/
	function set_evenement($timestamp, $nom, $description = '', $description_long = '', $lien = '', $nom_lien = '', $lien_out = true)
	{
		$this->evenement[ date('n', $timestamp) ][ date('d', $timestamp) ][ intval($timestamp) ] = array(
							'DESCRIPTION_LONG'	=> addslashes($description_long),
							'DESCRIPTION'	=> addslashes($description),
							'LIEN_OUT'	=> $lien_out,
							'NOM_LIEN'	=> addslashes($nom_lien),
							'LIEN'	=> addslashes($lien),
							'TIME'	=> intval($timestamp),
							'NOM'	=> addslashes($nom)
						);
	}

	/**
	* Permet de dfinir une traduction de nom de jour ou de mois
	* @param array $day Tableau conteant une traduction des jours de type array('dim', 'lun', 'mar',... )
	* @param array $month Tableau conteant une traduction des mois de type array('janv', 'fev', ...)
	* @param const $day_short taille des jours
	* @param const $month_short taille des mois
	*/
	function set_lang($day = array(), $month = array(), $day_short = CALENDAR_SHORT_DAY, $month_short = CALENDAR_LONG_DAY)
	{
		$this->lng_day = $day;
		$this->lng_month = $month;
		$this->short_day = $day_short;
		$this->short_month = $month_short;
	}

	/**
	* retourne le calendrier analys
	* @param timestamp $timestamp date ( optionel si set_debut  t utilis )
	* @return string calendrier  affficher
	*/
	function get_calendar($timestamp = '')
	{
		return $this->parse_calendar( intval($timestamp) );
	}

	/**
	* affiche le calendrier aprs analyse
	* @param timestamp $timestamp date ( optionel si set_debut  t utilis )
	*/
	function print_calendar($timestamp = '')
	{
		echo $this->parse_calendar( intval($timestamp) );
	}

	/**
	* analyse le calendrier
	* @access private
	* @param timestamp $timestamp date ( optionel si set_debut  t utilis )
	* @return string calendrier  afficher 
	*/
	function parse_calendar($timestamp = '')
	{
		if ($timestamp == '')
			$timestamp = $this->ftime;
		$calendar = '';
		if ($this->periode == CALENDAR_PERIODE_MONTH)
		{
			$i = $this->nbr_periode;
			$num_month = date('n', $timestamp);
			$num_year = date('y', $timestamp);

			while($i > 0)
			{
				if($i == $this->nbr_periode)
				{
					$calendar .= $this->make_month($timestamp);
				}
				else
				{
					$num_month = ($num_month >= 12)? 1 : $num_month + 1;
					$num_year = ($num_month >= 12)? $num_year + 1 : $num_year;
					// on met tjs le premier du mois pour viter les inconvnient du 30-31 fvrier ...
					$calendar .= $this->make_month( mktime(0, 0, 0, $num_month, 1, $num_year), false);
				}
				$i--;
			}
		}
		return $calendar;
	}

	/**
	* Remet toutes les variables sur leur valeurs par dfaut.
	*/
	function reset()
	{
		$this->html_v = CALENDAR_TYPE_HTML;
		$this->periode = CALENDAR_PERIODE_MONTH;
		$this->set_periode();
		$this->fday = CALENDAR_DAY_MON;
		$this->evenement = array();
		$this->ftime = time();
		$this->lng_day = array();
		$this->lng_month = array();
		$this->short_day = -1;
		$this->short_month = -1;
		$this->ftime = time();
	}

	/**
	* fabrique le code pour l'entte du/des jour
	*
	* @param timestamp $day timestamp du jour
	* @param boolean $a_week true -> crer une semaine
	* @return array
	*/
	function make_head_day($day, $a_week = true)
	{
		$code_d = array();
		if ($this->short_day == CALENDAR_SHORT_DAY)
		{
			$is_trans = true;
		}
		else
		{
			$is_trans = (count($this->lng_day) > 0)? false : true;
		}

		if ($this->html_v == CALENDAR_TYPE_HTML)
		{
			if ($a_week)
			{
				for($i = 0; $i < 7; $i++)
				{
					$code_d[ $i ] = '<td class="calendar_day_head">' . (  (!$is_trans)? $i : $this->lng_day[ $i ]  ) . '</td>' . "\n";
				}
			}
			else
			{
				$i = date('w',$day);
				$code_d[ $i ] = '<td class="calendar_day_head">' . (  (!$is_trans)? $i : $this->lng_day[ $i ]  ) . '</td>' . "\n";
			}
		}
		elseif ($this->html_v == CALENDAR_TYPE_XML)
		{
			if ($a_week)
			{
				for($i = 0; $i < 7; $i++)
				{
					$code_d[ $i ] = '<head_day>' . (  (!$is_trans)? $i : $this->lng_day[ $i ]  ) . '</head_day>' . "\n";
				}
			}
			else
			{
				$i = date('w',$day);
				$code_d[ $i ] = '<head_day>' . (  (!$is_trans)? $i : $this->lng_day[ $i ]  ) . '</head_day>' . "\n";
			}
		}

		return $code_d;
	}

	/**
	* fabrique le code pour un jour
	* @param timestamp $day timestamp du jour
	* @param boolean $select true -> est mis en vidence
	* @param boolean $blank true -> c'est un jour blanc
	*/
	function make_day($day, $select = false, $blank = false)
	{
		$code_d = '';

		if ($this->html_v == CALENDAR_TYPE_HTML)
		{
			$code_d .= ($select)?'<td class="calendar_day_selected">':'<td class="calendar_day">';
			if ($blank)
			{
				$code_d .= '&nbsp;';
			}
			else
			{
				$code_d .= '<span class="calendar_day_numday">' . date('d', $day) . '</span>';
				if (isset( $this->evenement[ date('n', $day) ] ) && isset( $this->evenement[ date('n', $day) ][ date('d', $day) ]) )
				{
					$my_even = $this->evenement[ date('n', $day) ][ date('d', $day) ];
					
					if (count($my_even) > 0)
					{
						ksort($my_even);
						$code_d .= "\n" . '<br /><ul class="calendar_day_evenement">';
						foreach ($my_even as $evenement)
						{
							$code_d .= '<li>';
							$code_d .= '<span class="calendar_day_evenement_nom">' . date('H:i') . '&nbsp;' . stripslashes($evenement['NOM']) . '</span><br />';
							if ($evenement['LIEN'] != '')
							{
								$code_d .= '<a href="' . stripslashes($evenement['LIEN']) . '"' . ( ($evenement['LIEN_OUT'])?' target="_blank"':'' ) . ' >' . stripslashes($evenement['NOM_LIEN']) . '</a>';
							}
							if ($evenement['DESCRIPTION'] != '')
							{
								$code_d .= '<div class="calendar_day_evenement_description">' . stripslashes($evenement['DESCRIPTION']) . '</div>';
							}
							if ($evenement['DESCRIPTION_LONG'] != '')
							{
								$code_d .= '<div class="calendar_day_evenement_descriptionL">' . stripslashes($evenement['DESCRIPTION_LONG']) . '</div>';
							}
							$code_d .= '</li>' . "\n";
						}
						$code_d .= '</ul>' . "\n";
					}
				}
			}
			$code_d .= '</td>' . "\n";
		}
		elseif ($this->html_v == CALENDAR_TYPE_XML)
		{
			$code_d .= (($select)?'<day_selected>':'<day>') . "\n";
			if ($blank)
			{
				$code_d .= ' ' . "\n";
			}
			else
			{
				$code_d .= '<numday>' . date('d', $day) . '</numday>' . "\n";
				if (isset( $this->evenement[ date('n', $day) ] ) && isset( $this->evenement[ date('n', $day) ][ date('d', $day) ]) )
				{
					$my_even = $this->evenement[ date('n', $day) ][ date('d', $day) ];
					
					if (count($my_even) > 0)
					{
						ksort($my_even);
						$code_d .= '<evenements>' . "\n";
						foreach ($my_even as $evenement)
						{
							$code_d .= '<evenement>' . "\n";
							$code_d .= '<nom>' . date('H:i') . '&nbsp;' . stripslashes($evenement['NOM']) . '</nom>' . "\n";
							if ($evenement['LIEN'] != '')
							{
								$code_d .= '<a href="' . stripslashes($evenement['LIEN']) . '"' . ( ($evenement['LIEN_OUT'])?' target="_blank"':'' ) . ' >' . stripslashes($evenement['NOM_LIEN']) . '</a>';
							}
							if ($evenement['DESCRIPTION'] != '')
							{
								$code_d .= '<desription>' . stripslashes($evenement['DESCRIPTION']) . '</description>' . "\n";
							}
							if ($evenement['DESCRIPTION_LONG'] != '')
							{
								$code_d .= '<desriptionlongue>' . stripslashes($evenement['DESCRIPTION_LONG']) . '</desriptionlongue>' . "\n";
							}
							$code_d .= '</evenement>' . "\n";
						}
						$code_d .= '</evenements>' . "\n";
					}
				}
			}
			$code_d .= (($select)?'</day_selected>':'</day>')  . "\n";
		}
		return $code_d;
	}

	/**
	* fabrique le code pour un mois
	* @param timestamp $month timestamp du mois, avec le jour slectionner.
	* @param boolean $day_selet true -> met en vidence le jour slectionner.
	* @return string le code d'un mois
	*/
	function make_month($month, $day_selet = true)
	{
		$code_s = '';
		$day_by_month = date('t', $month);
		$num_month = date('n', $month);
		$year = date('Y', $month);
		$first_day_of_month = date('w', mktime(0, 0, 0, $num_month, 1, $year) );

		$head_week = $this->make_head_day($month);
		$head_week_s = '';
		switch ($this->fday)
		{
			case CALENDAR_DAY_MON:
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				break;
			case CALENDAR_DAY_TUE:
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				break;
			case CALENDAR_DAY_WED:
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				break;
			case CALENDAR_DAY_THU:
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				break;
			case CALENDAR_DAY_FRI:
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				break;
			case CALENDAR_DAY_SAT:
				$head_week_s .= $head_week[6];
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				break;
			case CALENDAR_DAY_SUN:
				$head_week_s .= $head_week[0];
				$head_week_s .= $head_week[1];
				$head_week_s .= $head_week[2];
				$head_week_s .= $head_week[3];
				$head_week_s .= $head_week[4];
				$head_week_s .= $head_week[5];
				$head_week_s .= $head_week[6];
				break;
		}

		if ($this->short_day == CALENDAR_SHORT_DAY)
		{
			$is_trans = true;
		}
		else
		{
			$is_trans = (count($this->lng_day) > 0)? false : true;
		}

		if ($this->html_v == CALENDAR_TYPE_HTML)
		{
			$code_s .= '<table class="calendar_month"><tr><td colspan="7" class="calendar_month_head">' . ( (!$is_trans)? $num_month : $this->lng_month[ $num_month ] ) . '</td></tr>' . "\n";
		}
		elseif ($this->html_v == CALENDAR_TYPE_XML)
		{
			$code_s .= '<month><month_head>' . ( (!$is_trans)? $num_month : $this->lng_month[ $num_month ] ) . '</month_head>' . "\n";
		}
		$code_s .= $head_week_s;
		unset ($head_week_s);

		// si le premier jour du mois est diffrent du premier jour de la semaine il faut ajout des blancs
		$diff_fday = $first_day_of_month - $this->fday;
		if ($diff_fday < 0)
		{
			$diff_fday += 7;
		}

		$a_week_cpt = $diff_fday;
		
		if ($a_week_cpt != 0)
		{
			if ($this->html_v == CALENDAR_TYPE_HTML)
			{
				$code_s .= '<tr>' . "\n";
			}
			elseif ($this->html_v == CALENDAR_TYPE_XML)
			{
				$code_s .= '<week>' . "\n";
			}

			while ($diff_fday > 0)
			{
				$code_s .= $this->make_day(0, false, true);
				$diff_fday--;
			}
		}

		// on fait un retour  la ligne ( en html ) si on est  $a_week_cpt = 6
		$i = 1;
		while ($i <= $day_by_month)
		{
			if ($a_week_cpt == 0)
			{
				if ($this->html_v == CALENDAR_TYPE_HTML)
				{
					$code_s .= '<tr>' . "\n";
				}
				elseif ($this->html_v == CALENDAR_TYPE_XML)
				{
					$code_s .= '<week>' . "\n";
				}
			}

			if(($day_selet) && ($i == date('d', $month)) )
			{
				$code_s .= $this->make_day(mktime(0, 0, 0, $num_month, $i, $year), true);
			}
			else
			{
				$code_s .= $this->make_day(mktime(0, 0, 0, $num_month, $i, $year));
			}
			$a_week_cpt++;

			if($a_week_cpt >= 7)
			{
				$a_week_cpt = 0;
				if ($this->html_v == CALENDAR_TYPE_HTML)
				{
					$code_s .= '</tr>' . "\n";
				}
				elseif ($this->html_v == CALENDAR_TYPE_XML)
				{
					$code_s .= '</week>' . "\n";
				}
			}
			$i++;
		}
		unset($i);

		if ($a_week_cpt > 0)
		{
			while($a_week_cpt <= 6)
			{
				$code_s .= $this->make_day(0, false, true);
				$a_week_cpt++;
			}
			unset($a_week_cpt);
			if ($this->html_v == CALENDAR_TYPE_HTML)
			{
				$code_s .= '</tr>' . "\n";
			}
			elseif ($this->html_v == CALENDAR_TYPE_XML)
			{
				$code_s .= '</week>' . "\n";
			}
		}

		if ($this->html_v == CALENDAR_TYPE_HTML)
		{
			$code_s .= '</table>' . "\n";
		}
		elseif ($this->html_v == CALENDAR_TYPE_XML)
		{
			$code_s .= '</month>' . "\n";
		}
		return $code_s;
	}
}

?>